Index: trunk/AGRIF/LIB/fortran.y
===================================================================
--- trunk/AGRIF/LIB/fortran.y	(revision 530)
+++ trunk/AGRIF/LIB/fortran.y	(revision 663)
@@ -1848,98 +1882,118 @@
                             /* it is like an end subroutine <name>            */
                             insubroutinedeclare = 0 ;
-                            paramdeclaration_everdone = 0;
-                            tmpdeclaration_everdone = 0;
                             /*                                                */
-                            closeandcallsubloopandincludeit_0(1,$1,"");
-                            /* at the end of the firstpas  we should remove   */
-                            /*    from the listvarindoloop all variables      */
-                            /*    which has not been declared as table in the */
-                            /*    globliste                                   */
-                            cleanlistvarfordoloop_1(1);
+                            pos_cur = setposcur();
+                            closeandcallsubloopandincludeit_0(1,$1);
+                            functiondeclarationisdone = 0;
                          }
                          else
                          {
-                            /* if we never meet the contains keyword          */
-                            if ( inmoduledeclare == 1 )
-                            {
-                               if ( aftercontainsdeclare == 0 )
-                               {
-                                 CompleteGlobListeWithDatalist_1();
-                                 addsubroutine_alloc_0(1);
-                               }
-                            }
                             /* it is like an end module <name>                */
-                            inmoduledeclare = 0 ; 
-                            inmodulemeet = 0 ; 
+                            inmoduledeclare = 0 ;
+                            inmodulemeet = 0 ;
                          }
                        }
                        else
                        {
-                          paramdeclaration_everdone = 0;
-                          tmpdeclaration_everdone = 0;
                           insubroutinedeclare = 0;
                           /*                                                  */
-                          closeandcallsubloopandincludeit_0(2,$1,"");
-                          /* it is like end subroutine or end program         */
-                          /*  Common case                                     */
-                          /* at the end of the firstpas  we should remove     */
-                          /*    from the listvarindoloop all variables which  */
-                          /*    has not been declared as table in the         */
-                          /*    globliste                                     */
-                          cleanlistvarfordoloop_1(1);
-                       }
+                          pos_cur = setposcur();
+                          closeandcallsubloopandincludeit_0(2,$1);
+                            functiondeclarationisdone = 0;
+                          if ( firstpass == 0 )
+                          {
+                             if ( retour77 == 0 ) fprintf(paramout,"!\n");
+                             else fprintf(paramout,"C\n");
+                             fclose(paramout);
+                           }
+                        }
+                      }
+                      strcpy(subroutinename,"");
                     }
-      | TOK_ENDPROGRAM opt_name
+      | word_endprogram opt_name
                     {
-                       tmpdeclaration_everdone = 0;
-                         paramdeclaration_everdone = 0;
+                       if ( couldaddvariable == 1 )
+                       {
                        insubroutinedeclare = 0;
                        /*                                                     */
-                       closeandcallsubloopandincludeit_0(3,$1,$2);
-                       /*  Common case                                        */
-                       /* at the end of the firstpas  we should remove from   */
-                       /*    the listvarindoloop all variables which has not  */
-                       /*    been declared as table in the globliste          */
-                       cleanlistvarfordoloop_1(3);
+                       pos_cur = setposcur();
+                       closeandcallsubloopandincludeit_0(3,$1);
+                            functiondeclarationisdone = 0;
+                      if ( firstpass == 0 )
+                      {
+                         if ( retour77 == 0 ) fprintf(paramout,"!\n");
+                         else fprintf(paramout,"C\n");
+                         fclose(paramout);
+                      }
+                      strcpy(subroutinename,"");
+                      }
                     }
-      | TOK_ENDSUBROUTINE opt_name
+      | word_endsubroutine opt_name
                     {
-                       tmpdeclaration_everdone = 0;
-                       paramdeclaration_everdone = 0;
+                       if ( couldaddvariable == 1 &&
+                            strcasecmp(subroutinename,"") )
+                       {
                        insubroutinedeclare = 0;
                        /*                                                     */
-                       closeandcallsubloopandincludeit_0(1,$1,$2);
-                       /*  Common case                                        */
-                       /* at the end of the firstpas  we should remove from   */
-                       /*    the listvarindoloop all variables which has not  */
-                       /*    been declared as table in the globliste          */
-                       cleanlistvarfordoloop_1(1);
+                       pos_cur = setposcur();
+                       closeandcallsubloopandincludeit_0(1,$1);
+                            functiondeclarationisdone = 0;
+                      if ( firstpass == 0 )
+                      {
+                         if ( retour77 == 0 ) fprintf(paramout,"!\n");
+                         else fprintf(paramout,"C\n");
+                         fclose(paramout);
+                      }
+                      strcpy(subroutinename,"");
+                      }
                     }
-      | TOK_ENDFUNCTION opt_name
+      | word_endfunction opt_name
                     {
-                       tmpdeclaration_everdone = 0;
-                       paramdeclaration_everdone = 0;
+                       if ( couldaddvariable == 1 )
+                       {
                        insubroutinedeclare = 0;
                        /*                                                     */
-                       closeandcallsubloopandincludeit_0(0,$1,$2);
-                       /*  Common case                                        */
-                       /* at the end of the firstpas  we should remove from   */
-                       /*    the listvarindoloop all variables which has not  */
-                       /*    been declared as table in the globliste          */
-                       cleanlistvarfordoloop_1(0);
+                       pos_cur = setposcur();
+                       closeandcallsubloopandincludeit_0(0,$1);
+                            functiondeclarationisdone = 0;
+                      if ( firstpass == 0 )
+                      {
+                         if ( retour77 == 0 ) fprintf(paramout,"!\n");
+                         else fprintf(paramout,"C\n");
+                         fclose(paramout);
+                      }
+                      strcpy(subroutinename,"");
+                      }
                     }
       | TOK_ENDMODULE opt_name
                     {
+                       if ( couldaddvariable == 1 )
+                       {
                        /* if we never meet the contains keyword               */
+                      Remove_Word_end_module_0();
                        if ( inmoduledeclare == 1 )
                        {
                           if ( aftercontainsdeclare == 0 )
                           {
-                             CompleteGlobListeWithDatalist_1();
-                             addsubroutine_alloc_0(1);
+                             Write_GlobalParameter_Declaration_0();
+                             Write_NotGridDepend_Declaration_0();
+                             Write_Alloc_Subroutine_For_End_0();
                           }
                        }
-                       inmoduledeclare = 0 ; 
-                       inmodulemeet = 0 ; 
+                       inmoduledeclare = 0 ;
+                       inmodulemeet = 0 ;
+
+                      Write_Word_end_module_0();
+                      strcpy(curmodulename,"");
+                      aftercontainsdeclare = 1;
+                      if ( firstpass == 0 )
+                      {
+                         if ( module_declar && insubroutinedeclare == 0)
+                         {
+                           fclose(module_declar);
+                         }
+                      }
+                      GlobalDeclaration = 0 ;
+                      }
                   }
       | boucledo
@@ -1950,7 +2004,7 @@
       | logif TOK_THEN
       | TOK_ELSEIF  '(' expr ')' TOK_THEN
-      | TOK_ELSE 
-      | TOK_ENDIF
-      | TOK_CASE '(' caselist ')'
+      | TOK_ELSE
+      | TOK_ENDIF opt_name
+      | TOK_CASE caselist ')'
       | TOK_SELECTCASE '(' expr ')'
       | TOK_CASEDEFAULT
@@ -1960,23 +2014,83 @@
                       if (inmoduledeclare == 1 )
                       {
-                         CompleteGlobListeWithDatalist_1();
-                         addsubroutine_alloc_0(0);
-                      }
-                      inmoduledeclare = 0 ; 
-                      aftercontainsdeclare = 1;
-                   }
-      ;
-
+                         Remove_Word_Contains_0();
+                         Write_GlobalParameter_Declaration_0();
+                         Write_NotGridDepend_Declaration_0();
+                         Write_Alloc_Subroutine_0();
+                         inmoduledeclare = 0 ;
+                         aftercontainsdeclare = 1;
+                      }
+                      else
+                      {
+                       if ( couldaddvariable == 1 )
+                       {
+                          if ( firstpass == 1 ) List_ContainsSubroutine =
+                                                Addtolistnom(subroutinename,
+                                                     List_ContainsSubroutine,0);
+                          insubroutinedeclare = 0;
+                          /*                                                  */
+                          closeandcallsubloop_contains_0();
+                            functiondeclarationisdone = 0;
+                         if ( firstpass == 0 )
+                         {
+                            if ( retour77 == 0 ) fprintf(paramout,"!\n");
+                            else fprintf(paramout,"C\n");
+                            fclose(paramout);
+                         }
+                         }
+                         strcpy(subroutinename,"");
+                      }
+                   }
+      ;
+word_endsubroutine: TOK_ENDSUBROUTINE
+                    {
+                      if ( couldaddvariable == 1 )
+                      {
+                       strcpy($$,$1);
+                       pos_endsubroutine = setposcur()-strlen($1);
+                       functiondeclarationisdone = 0;
+                       }
+                    }
+      ;
+word_endunit: TOK_ENDUNIT
+                    {
+                      if ( couldaddvariable == 1 )
+                      {
+                       strcpy($$,$1);
+                       pos_endsubroutine = setposcur()-strlen($1);
+                       }
+                    }
+      ;
+word_endprogram:  TOK_ENDPROGRAM
+                    {
+                      if ( couldaddvariable == 1 )
+                      {
+                       strcpy($$,$1);
+                       pos_endsubroutine = setposcur()-strlen($1);
+                       }
+                    }
+      ;
+word_endfunction: TOK_ENDFUNCTION
+                    {
+                      if ( couldaddvariable == 1 )
+                      {
+                       strcpy($$,$1);
+                       pos_endsubroutine = setposcur()-strlen($1);
+                       }
+                    }
+      ;
 caselist: expr
       | caselist ',' expr
       | caselist ':' expr
       ;
-boucledo : worddo opt_int do_var '=' expr ',' expr
-      | worddo opt_int do_var '=' expr ',' expr ',' expr
+boucledo : worddo opt_int do_arg
       | wordwhile expr
       | TOK_ENDDO optname
       ;
-opt_int : 
-      | TOK_CSTINT
+do_arg :
+      | do_var '=' expr ',' expr
+      | do_var '=' expr ',' expr ',' expr
+opt_int :
+      | TOK_CSTINT opt_comma
       ;
 opt_name : '\n'  {strcpy($$,"");}
@@ -1989,5 +2103,5 @@
       ;
 wordwhile :TOK_DOWHILE
-      ;     
+      ;
 
 dotarget:
@@ -1999,7 +2113,15 @@
       | goto
       | io
-      | call 
+      | call
       | TOK_ALLOCATE '(' allocation_list opt_stat_spec ')'
+                     {
+                          Add_SubroutineWhereAgrifUsed_1(subroutinename,
+                                                        curmodulename);
+                     }
       | TOK_DEALLOCATE '(' allocate_object_list opt_stat_spec ')'
+                     {
+                          Add_SubroutineWhereAgrifUsed_1(subroutinename,
+                                                        curmodulename);
+                     }
       | TOK_EXIT optexpr
       | TOK_RETURN opt_expr
@@ -2010,5 +2132,13 @@
 before_dims : {if ( couldaddvariable == 1 ) created_dimensionlist = 0;}
 ident_dims : ident before_dims dims dims
-      {created_dimensionlist = 1;}
+              {
+                  created_dimensionlist = 1;
+                  if  ( agrif_parentcall == 1 )
+                  {
+                      ModifyTheAgrifFunction_0($3->dim.last);
+                      agrif_parentcall =0;
+                      fprintf(fortranout," = ");
+                  }
+              }
       | ident_dims '%' ident before_dims dims dims
       {created_dimensionlist = 1;}
@@ -2016,13 +2146,13 @@
       | int_list ',' TOK_CSTINT
       ;
-after_ident_dims : '=' expr 
-      | TOK_POINT_TO expr 
-      ;
-call: keywordcall opt_call 
+after_ident_dims : '=' expr
+      | TOK_POINT_TO expr
+      ;
+call: keywordcall opt_call
                    {
                       inagrifcallargument = 0 ;
                       incalldeclare=0;
-                      if ( oldfortranout && 
-                           !strcasecmp(meetagrifinitgrids,subroutinename) && 
+                      if ( oldfortranout &&
+                           !strcasecmp(meetagrifinitgrids,subroutinename) &&
                            firstpass == 0 &&
                            callmpiinit == 1)
@@ -2034,6 +2164,6 @@
                                                                    ,mpiinitvar);
                       }
-                      if ( oldfortranout           && 
-                           callagrifinitgrids == 1 && 
+                      if ( oldfortranout           &&
+                           callagrifinitgrids == 1 &&
                            firstpass == 0 )
                       {
@@ -2041,6 +2171,5 @@
                          RemoveWordSET_0(fortranout,pos_curcall,
                                                pos_end-pos_curcall);
-                         fprintf(oldfortranout,
-                                           "      Call Agrif_Init_Grids () \n");
+
                          strcpy(subofagrifinitgrids,subroutinename);
                       }
@@ -2048,5 +2177,5 @@
                    }
       ;
-opt_call : 
+opt_call :
       | '(' opt_callarglist  ')'
       ;
@@ -2054,10 +2183,9 @@
       | callarglist
       ;
-keywordcall : before_call TOK_NAME 
+keywordcall : before_call TOK_NAME
                     {
-                       if (!strcasecmp($2,"MPI_Init") ) 
+                       if (!strcasecmp($2,"MPI_Init") )
                        {
                           callmpiinit = 1;
-                          strcpy(meetmpiinit,subroutinename);
                        }
                        else
@@ -2065,5 +2193,5 @@
                           callmpiinit = 0;
                        }
-                       if (!strcasecmp($2,"Agrif_Init_Grids") ) 
+                       if (!strcasecmp($2,"Agrif_Init_Grids") )
                        {
                           callagrifinitgrids = 1;
@@ -2071,9 +2199,15 @@
                        }
                        else callagrifinitgrids = 0;
-                       if ( Vartonumber($2) == 1 ) 
+                       if ( !strcasecmp($2,"Agrif_Open_File") )
+                       {
+                          Add_SubroutineWhereAgrifUsed_1(subroutinename,
+                                                        curmodulename);
+                       }
+                       if ( Vartonumber($2) == 1 )
                        {
                           incalldeclare=1;
                           inagrifcallargument = 1 ;
-                          AddsubroutineTolistsubwhereagrifused();
+                          Add_SubroutineWhereAgrifUsed_1(subroutinename,
+                                                        curmodulename);
                        }
                     }
@@ -2086,13 +2220,14 @@
 
 callarg:  expr {
-                  if ( callmpiinit == 1 ) 
+                  if ( callmpiinit == 1 )
                   {
                      strcpy(mpiinitvar,$1);
-                     if ( firstpass == 1 ) 
+                     if ( firstpass == 1 )
                      {
-                        curvar=createvar($1,NULL);
+                        Add_UsedInSubroutine_Var_1 (mpiinitvar);
+/*                        curvar=createvar($1,NULL);
                         curlistvar=insertvar(NULL,curvar);
-                        listargsubroutine = AddListvarToListvar
-                                               (curlistvar,listargsubroutine,1);
+                        List_Subr outineArgument_Var = AddListvarToListvar
+                         (curlistvar,List_SubroutineAr gument_Var,1);*/
                      }
                   }
@@ -2108,39 +2243,8 @@
       | read option_read
       | TOK_REWIND after_rewind
-      | print option_print
-      | wordformat debut_format ioctl_format fin_format
-                    {formatdeclare = 0;}
-      ;
-wordformat : TOK_FORMAT
-                    {formatdeclare = 1;}
-opt_ioctlformat : 
-      | ioctl_format
-      ;
-opt_ioctl_format : 
-      | ',' ioctl_format
-      | ',' '*'
-      ;
-debut_format : TOK_LEFTAB opt_comma
-      | '('
-      ;
-ioctl_format : format_expr
-      |   ioctl_format ',' format_expr
-      ;
-format_expr : 
-      | uexpr
-      | TOK_CSTINT TOK_CHAR_INT
-      | TOK_CSTINT debut_format ioctl_format fin_format
-      | TOK_SLASH opt_CHAR_INT
-      | TOK_CHAR_INT TOK_SLASH format_expr
-      | TOK_SLASH TOK_SLASH
-      | TOK_CHAR_INT
-      | '(' format_expr ')'
-      | '(' uexpr ')'
-      ;
-opt_CHAR_INT : 
+      | TOK_FORMAT
+      ;
+opt_CHAR_INT :
       | TOK_CSTINT TOK_NAME
-      ;
-fin_format : opt_comma TOK_RIGHTAB opt_comma
-      | ')'
       ;
 idfile : '*'
@@ -2164,7 +2268,10 @@
       ;
 ioctl:  '(' ctllist ')'
-      | '(' fexpr ')' 
+      | '(' fexpr ')'
       ;
 after_rewind:  '(' ident ')'
+      | '(' TOK_CSTINT ')'
+      | TOK_CSTINT
+      | '(' uexpr ')'
       | TOK_NAME
       ;
@@ -2172,12 +2279,12 @@
       | ctllist ',' ioclause
       ;
-ioclause: fexpr 
+ioclause: fexpr
       | '*'
       | TOK_DASTER
-      | TOK_NAME expr 
+      | TOK_NAME expr
       | TOK_NAME expr '%' ident_dims
       | TOK_NAME '(' triplet ')'
-      | TOK_NAME '*' 
-      | TOK_NAME TOK_DASTER 
+      | TOK_NAME '*'
+      | TOK_NAME TOK_DASTER
       ;
 iofctl: TOK_OPEN
@@ -2191,7 +2298,5 @@
       | TOK_INQUIRE
       | TOK_WRITE
-      ;
-print: TOK_PRINT fexpr
-      | TOK_PRINT '*'
+      | TOK_PRINT
       ;
 fexpr: unpar_fexpr
@@ -2208,4 +2313,6 @@
       | TOK_FILE expr
       | TOK_EXIST expr
+      | TOK_ERR expr
+      | TOK_END expr
       | TOK_NAME '=' expr
       ;
@@ -2216,5 +2323,5 @@
       | inlist ',' inelt
       ;
-opt_lhs : 
+opt_lhs :
       | lhs
       ;
@@ -2222,5 +2329,5 @@
       | '(' inlist ')' opt_operation
       | predefinedfunction opt_operation
-      | simple_const opt_operation 
+      | simple_const opt_operation
       | '(' inlist ',' dospec ')'
       ;
@@ -2228,39 +2335,41 @@
       | operation
       | opt_operation operation
-      ;      
-outlist: other      {strcpy($$,$1);} 
-      | out2       {strcpy($$,$1);} 
+      ;
+outlist: other      {if ( couldaddvariable == 1 ) strcpy($$,$1);}
+      | out2       {if ( couldaddvariable == 1 ) strcpy($$,$1);}
       ;
 out2: uexpr ',' expr
-                   {sprintf($$,"%s,%s",$1,$3);} 
-      | uexpr ',' other 
-                   {sprintf($$,"%s,%s",$1,$3);} 
-      | other ',' expr 
-                   {sprintf($$,"%s,%s",$1,$3);} 
-      | other ',' other 
-                   {sprintf($$,"%s,%s",$1,$3);} 
-      | out2 ',' expr 
-                   {sprintf($$,"%s,%s",$1,$3);} 
-      | out2 ',' other 
-                   {sprintf($$,"%s,%s",$1,$3);} 
-      | uexpr     {strcpy($$,$1);} 
-      | predefinedfunction {strcpy($$,$1);} 
-      ;
-other:  complex_const 
-                   {strcpy($$,$1);} 
-      | '(' expr ')' 
-                   {sprintf($$," (%s)",$2);} 
+                   {if ( couldaddvariable == 1 ) sprintf($$,"%s,%s",$1,$3);}
+      | uexpr ',' other
+                   {if ( couldaddvariable == 1 ) sprintf($$,"%s,%s",$1,$3);}
+      | other ',' expr
+                   {if ( couldaddvariable == 1 ) sprintf($$,"%s,%s",$1,$3);}
+      | other ',' other
+                   {if ( couldaddvariable == 1 ) sprintf($$,"%s,%s",$1,$3);}
+      | out2 ',' expr
+                   {if ( couldaddvariable == 1 ) sprintf($$,"%s,%s",$1,$3);}
+      | out2 ',' other
+                   {if ( couldaddvariable == 1 ) sprintf($$,"%s,%s",$1,$3);}
+      | uexpr     {if ( couldaddvariable == 1 ) strcpy($$,$1);}
+      | predefinedfunction {if ( couldaddvariable == 1 ) strcpy($$,$1);}
+      ;
+other:  complex_const
+                   {if ( couldaddvariable == 1 ) strcpy($$,$1);}
+      | '(' expr ')'
+                   {if ( couldaddvariable == 1 ) sprintf($$," (%s)",$2);}
       | '(' uexpr ',' dospec ')'
-                   {sprintf($$,"(%s,%s)",$2,$4);} 
+                   {if ( couldaddvariable == 1 ) sprintf($$,"(%s,%s)",$2,$4);}
       | '(' other ',' dospec ')'
-                   {sprintf($$,"(%s,%s)",$2,$4);} 
+                   {if ( couldaddvariable == 1 ) sprintf($$,"(%s,%s)",$2,$4);}
       | '(' out2 ',' dospec ')'
-                   {sprintf($$,"(%s,%s)",$2,$4);} 
-      ;
-
-dospec: TOK_NAME '=' expr ',' expr 
-                   {sprintf($$,"%s=%s,%s)",$1,$3,$5);} 
-      | TOK_NAME '=' expr ',' expr ',' expr 
-                   {sprintf($$,"%s=%s,%s,%s)",$1,$3,$5,$7);} 
+                   {if ( couldaddvariable == 1 ) sprintf($$,"(%s,%s)",$2,$4);}
+      ;
+
+dospec: TOK_NAME '=' expr ',' expr
+                   {if ( couldaddvariable == 1 )
+                                              sprintf($$,"%s=%s,%s)",$1,$3,$5);}
+      | TOK_NAME '=' expr ',' expr ',' expr
+                   {if ( couldaddvariable == 1 )
+                                        sprintf($$,"%s=%s,%s,%s)",$1,$3,$5,$7);}
       ;
 labellist: label
@@ -2269,5 +2378,6 @@
 label: TOK_CSTINT
       ;
-goto: TOK_PLAINGOTO label
+goto: TOK_PLAINGOTO '(' expr ',' expr ')' ',' expr
+      | TOK_PLAINGOTO label
       ;
 allocation_list: allocate_object
@@ -2276,13 +2386,13 @@
       ;
 allocate_object: ident
-                   {AddIdentToTheAllocateList_1($1);}
+                   {Add_Allocate_Var_1($1,curmodulename);}
       | structure_component
       | array_element
       ;
-array_element: ident '(' funargs ')' 
-                   {AddIdentToTheAllocateList_1($1);}
-      ;
-subscript_list: expr 
-      | subscript_list ',' expr 
+array_element: ident '(' funargs ')'
+                   {Add_Allocate_Var_1($1,curmodulename);}
+      ;
+subscript_list: expr
+      | subscript_list ',' expr
       ;
 
@@ -2317,42 +2427,42 @@
 
    /*fortrandebug = 1;*/
+   if ( mark == 1 ) printf("Firstpass == %d \n",firstpass);
 /******************************************************************************/
 /*  1-  Open input and output files                                           */
 /******************************************************************************/
-   strcpy(OriginalFileName,fichier_entree); 
    strcpy(nomfile,commondirin);
    strcat(nomfile,"/");
    strcat(nomfile,fichier_entree);
    fortranin=fopen( nomfile,"r");
-   if (! fortranin) 
+   if (! fortranin)
    {
       printf("Error : File %s does not exist\n",nomfile);
       exit(1);
    }
-   
+
    strcpy(curfile,nomfile);
    strcpy(nomfile,commondirout);
-   strcat(nomfile,"/");  
+   strcat(nomfile,"/");
    strcat(nomfile,fichier_entree);
    strcpy(nomfileoutput,nomfile);
-   if (firstpass == 1) 
+   if (firstpass == 1)
    {
-      if (checkexistcommon == 1) 
+      if (checkexistcommon == 1)
       {
-         if (fopen(nomfile,"r")) 
+         if (fopen(nomfile,"r"))
          {
             printf("Warning : file %s already exist\n",nomfile);
             confirmyes = 0;
-            while (confirmyes==0) 
+            while (confirmyes==0)
             {
                printf("Override file %s ? [Y/N]\n",nomfile);
                c=getchar();
-               getchar();    
-               if (c==79 || c==110) 
+               getchar();
+               if (c==79 || c==110)
                {
                   printf("We stop\n");
                   exit(1);
                }
-               if (c==89 || c==121) 
+               if (c==89 || c==121)
                {
                   confirmyes=1;
@@ -2361,5 +2471,5 @@
          }
       }
-   }  
+   }
 
 /******************************************************************************/
@@ -2367,25 +2477,25 @@
 /******************************************************************************/
 
-   line_num_fortran_common=1; 
+   line_num_fortran_common=1;
    line_num_fortran=1;
-   PublicDeclare = 0;  
-   PrivateDeclare = 0; 
-   formatdeclare = 0;
-   ExternalDeclare = 0; 
+   PublicDeclare = 0;
+   PrivateDeclare = 0;
+   ExternalDeclare = 0;
    SaveDeclare = 0;
-   indeclarationvar=0;
    pointerdeclare = 0;
    optionaldeclare = 0;
    incalldeclare = 0;
-   infunctiondeclare = 0 ;
+   VarType = 0;
+   VarTypepar = 0;
    Allocatabledeclare = 0 ;
-   strcpy(NamePrecision," "); 
-   VariableIsParameter =  0 ; 
-   strcpy(NamePrecision,"");  
-   c_star = 0 ; 
+   strcpy(NamePrecision," ");
+   VariableIsParameter =  0 ;
+   strcpy(NamePrecision,"");
+   c_star = 0 ;
+   functiondeclarationisdone = 0;
    insubroutinedeclare = 0 ;
-   strcpy(subroutinename," "); 
-   InitialValueGiven = 0 ; 
-   strcpy(EmptyChar," "); 
+   strcpy(subroutinename," ");
+   InitialValueGiven = 0 ;
+   strcpy(EmptyChar," ");
    inmoduledeclare = 0;
    colnum=0;
@@ -2395,14 +2505,13 @@
    /* Name of the file without format                                         */
    tmp = strchr(fichier_entree, '.');
-   strncpy(curfilename,fichier_entree,strlen(fichier_entree)-strlen(tmp)); 
+   strncpy(curfilename,fichier_entree,strlen(fichier_entree)-strlen(tmp));
 /******************************************************************************/
-/*  2-  Parsing of the input file (1 time)                                    */
+/*  3-  Parsing of the input file (1 time)                                    */
 /******************************************************************************/
-   if (firstpass == 0 ) 
+   if (firstpass == 0 )
    {
       fortranout=fopen(nomfileoutput,"w");
-      /* we should add the new module comes from common block                 */
-      if (fortran77 == 1 ) fprintf
-                      (fortranout,"#include \"NewModule_%s.h\" \n",curfilename);
+
+      NewModule_Creation_0();
    }
 
